Code

inet_ntop.c: Work around GCC 4.6's detection of uninitialized variables
[git.git] / t / lib-git-svn.sh
1 . ./test-lib.sh
3 remotes_git_svn=remotes/git""-svn
4 git_svn_id=git""-svn-id
6 if test -n "$NO_SVN_TESTS"
7 then
8         skip_all='skipping git svn tests, NO_SVN_TESTS defined'
9         test_done
10 fi
11 if ! test_have_prereq PERL; then
12         skip_all='skipping git svn tests, perl not available'
13         test_done
14 fi
16 GIT_DIR=$PWD/.git
17 GIT_SVN_DIR=$GIT_DIR/svn/refs/remotes/git-svn
18 SVN_TREE=$GIT_SVN_DIR/svn-tree
20 svn >/dev/null 2>&1
21 if test $? -ne 1
22 then
23     skip_all='skipping git svn tests, svn not found'
24     test_done
25 fi
27 svnrepo=$PWD/svnrepo
28 export svnrepo
29 svnconf=$PWD/svnconf
30 export svnconf
32 "$PERL_PATH" -w -e "
33 use SVN::Core;
34 use SVN::Repos;
35 \$SVN::Core::VERSION gt '1.1.0' or exit(42);
36 system(qw/svnadmin create --fs-type fsfs/, \$ENV{svnrepo}) == 0 or exit(41);
37 " >&3 2>&4
38 x=$?
39 if test $x -ne 0
40 then
41         if test $x -eq 42; then
42                 skip_all='Perl SVN libraries must be >= 1.1.0'
43         elif test $x -eq 41; then
44                 skip_all='svnadmin failed to create fsfs repository'
45         else
46                 skip_all='Perl SVN libraries not found or unusable'
47         fi
48         test_done
49 fi
51 rawsvnrepo="$svnrepo"
52 svnrepo="file://$svnrepo"
54 poke() {
55         test-chmtime +1 "$1"
56 }
58 # We need this, because we should pass empty configuration directory to
59 # the 'svn commit' to avoid automated property changes and other stuff
60 # that could be set from user's configuration files in ~/.subversion.
61 svn_cmd () {
62         [ -d "$svnconf" ] || mkdir "$svnconf"
63         orig_svncmd="$1"; shift
64         if [ -z "$orig_svncmd" ]; then
65                 svn
66                 return
67         fi
68         svn "$orig_svncmd" --config-dir "$svnconf" "$@"
69 }
71 for d in \
72         "$SVN_HTTPD_PATH" \
73         /usr/sbin/apache2 \
74         /usr/sbin/httpd \
75 ; do
76         if test -f "$d"
77         then
78                 SVN_HTTPD_PATH="$d"
79                 break
80         fi
81 done
82 for d in \
83         "$SVN_HTTPD_MODULE_PATH" \
84         /usr/lib/apache2/modules \
85         /usr/libexec/apache2 \
86 ; do
87         if test -d "$d"
88         then
89                 SVN_HTTPD_MODULE_PATH="$d"
90                 break
91         fi
92 done
94 start_httpd () {
95         repo_base_path="$1"
96         if test -z "$SVN_HTTPD_PORT"
97         then
98                 echo >&2 'SVN_HTTPD_PORT is not defined!'
99                 return
100         fi
101         if test -z "$repo_base_path"
102         then
103                 repo_base_path=svn
104         fi
106         mkdir "$GIT_DIR"/logs
108         cat > "$GIT_DIR/httpd.conf" <<EOF
109 ServerName "git svn test"
110 ServerRoot "$GIT_DIR"
111 DocumentRoot "$GIT_DIR"
112 PidFile "$GIT_DIR/httpd.pid"
113 LockFile logs/accept.lock
114 Listen 127.0.0.1:$SVN_HTTPD_PORT
115 LoadModule dav_module $SVN_HTTPD_MODULE_PATH/mod_dav.so
116 LoadModule dav_svn_module $SVN_HTTPD_MODULE_PATH/mod_dav_svn.so
117 <Location /$repo_base_path>
118         DAV svn
119         SVNPath "$rawsvnrepo"
120 </Location>
121 EOF
122         "$SVN_HTTPD_PATH" -f "$GIT_DIR"/httpd.conf -k start
123         svnrepo="http://127.0.0.1:$SVN_HTTPD_PORT/$repo_base_path"
126 stop_httpd () {
127         test -z "$SVN_HTTPD_PORT" && return
128         "$SVN_HTTPD_PATH" -f "$GIT_DIR"/httpd.conf -k stop
131 convert_to_rev_db () {
132         "$PERL_PATH" -w -- - "$@" <<\EOF
133 use strict;
134 @ARGV == 2 or die "Usage: convert_to_rev_db <input> <output>";
135 open my $wr, '+>', $ARGV[1] or die "$!: couldn't open: $ARGV[1]";
136 open my $rd, '<', $ARGV[0] or die "$!: couldn't open: $ARGV[0]";
137 my $size = (stat($rd))[7];
138 ($size % 24) == 0 or die "Inconsistent size: $size";
139 while (sysread($rd, my $buf, 24) == 24) {
140         my ($r, $c) = unpack('NH40', $buf);
141         my $offset = $r * 41;
142         seek $wr, 0, 2 or die $!;
143         my $pos = tell $wr;
144         if ($pos < $offset) {
145                 for (1 .. (($offset - $pos) / 41)) {
146                         print $wr (('0' x 40),"\n") or die $!;
147                 }
148         }
149         seek $wr, $offset, 0 or die $!;
150         print $wr $c,"\n" or die $!;
152 close $wr or die $!;
153 close $rd or die $!;
154 EOF
157 require_svnserve () {
158     if test -z "$SVNSERVE_PORT"
159     then
160         skip_all='skipping svnserve test. (set $SVNSERVE_PORT to enable)'
161         test_done
162     fi
165 start_svnserve () {
166     svnserve --listen-port $SVNSERVE_PORT \
167              --root "$rawsvnrepo" \
168              --listen-once \
169              --listen-host 127.0.0.1 &